"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HtmlEditorLoader = void 0;
var react_1 = __importStar(require("react"));
var dynamic_1 = __importDefault(require("next/dynamic"));
var lodash_1 = require("lodash");
var primeobjects_helper_util_1 = require("primeobjects-helper-util");
var css_1 = require("primeobjects-ui-web-basic/build/cjs/controls/css");
var html_css_1 = require("primeobjects-ui-web-html/build/cjs/html-css");
var HtmlEditorLoader = function (props) {
    var loadingContent = !(0, lodash_1.isNil)(props.loadingContent) ? props.loadingContent : 'Loading ...';
    var className = props.className ? props.className : '';
    var style = props.style ? props.style : {};
    var _a = (0, react_1.useState)(!(0, lodash_1.isNil)(primeobjects_helper_util_1._window.HtmlEditor)), loaded = _a[0], setLoaded = _a[1];
    var _b = (0, react_1.useState)(false), ready = _b[0], setReady = _b[1];
    (0, react_1.useEffect)(function () {
        if (!primeobjects_helper_util_1._window.HtmlEditor) {
            primeobjects_helper_util_1._window.HtmlEditor = (0, dynamic_1.default)(function () { return Promise.resolve().then(function () { return __importStar(require("primeobjects-ui-web-html/build/cjs/html-editor")); }); }, { ssr: false });
            setLoaded(true);
        }
    }, []);
    var HtmlEditor = primeobjects_helper_util_1._window.HtmlEditor;
    return react_1.default.createElement(react_1.default.Fragment, null,
        loaded && react_1.default.createElement(HtmlEditor, __assign({}, props, { className: ready ? className : "".concat(className, " hidden"), onReady: function () { setReady(true); } })),
        react_1.default.createElement(css_1.CSS, { id: "html-editor-css", content: html_css_1.HTML_EDITOR_CSS }),
        !ready && react_1.default.createElement("div", { className: className, style: style }, loadingContent));
};
exports.HtmlEditorLoader = HtmlEditorLoader;
exports.default = exports.HtmlEditorLoader;
